package cn.iocoder.yudao.module.llm.service.prompttemplatesapplications;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.llm.controller.admin.prompttemplatesapplications.vo.*;
import cn.iocoder.yudao.module.llm.dal.dataobject.prompttemplatesapplications.PromptTemplatesApplicationsDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.llm.dal.mysql.prompttemplatesapplications.PromptTemplatesApplicationsMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.llm.enums.ErrorCodeConstants.*;

/**
 * Prompt 模板 应用关系表，记录模板和应用之间的多对多关系 Service 实现类
 *
 * @author 华大大模型
 */
@Service
@Validated
public class PromptTemplatesApplicationsServiceImpl implements PromptTemplatesApplicationsService {

    @Resource
    private PromptTemplatesApplicationsMapper promptTemplatesApplicationsMapper;

    @Override
    public Long createPromptTemplatesApplications(PromptTemplatesApplicationsSaveReqVO createReqVO) {
        // 插入
        PromptTemplatesApplicationsDO promptTemplatesApplications = BeanUtils.toBean(createReqVO, PromptTemplatesApplicationsDO.class);
        promptTemplatesApplicationsMapper.insert(promptTemplatesApplications);
        // 返回
        return promptTemplatesApplications.getId();
    }

    @Override
    public void updatePromptTemplatesApplications(PromptTemplatesApplicationsSaveReqVO updateReqVO) {
        // 校验存在
        validatePromptTemplatesApplicationsExists(updateReqVO.getId());
        // 更新
        PromptTemplatesApplicationsDO updateObj = BeanUtils.toBean(updateReqVO, PromptTemplatesApplicationsDO.class);
        promptTemplatesApplicationsMapper.updateById(updateObj);
    }

    @Override
    public void deletePromptTemplatesApplications(Long id) {
        // 校验存在
        validatePromptTemplatesApplicationsExists(id);
        // 删除
        promptTemplatesApplicationsMapper.deleteById(id);
    }

    private void validatePromptTemplatesApplicationsExists(Long id) {
        if (promptTemplatesApplicationsMapper.selectById(id) == null) {
            throw exception(PROMPT_TEMPLATES_APPLICATIONS_NOT_EXISTS);
        }
    }

    @Override
    public PromptTemplatesApplicationsDO getPromptTemplatesApplications(Long id) {
        return promptTemplatesApplicationsMapper.selectById(id);
    }

    @Override
    public PageResult<PromptTemplatesApplicationsDO> getPromptTemplatesApplicationsPage(PromptTemplatesApplicationsPageReqVO pageReqVO) {
        return promptTemplatesApplicationsMapper.selectPage(pageReqVO);
    }

}
